
#define FONT_START_CHAR			'!'
#define FONT_END_CHAR			'~'
#define FONT_CHAR_COUNT		( '~' - '!' + 1 )

struct CHAR_TEXTURE {
	int32 width;
	int32 height;
	void * memory;
};

struct FONT_CHAR {
	vec2 dim;
	vec2 offset;
	flo32 advanceWidth;
};

struct FONT {
	int32 advanceWidth_space;
	flo32 ascent;
	flo32 descent;
	flo32 lineGap;
	flo32 advanceHeight;
	FONT_CHAR alphabet[ FONT_CHAR_COUNT ];
	int8 kernValue[ FONT_CHAR_COUNT * FONT_CHAR_COUNT ];
	
	CHAR_TEXTURE char_texture[ FONT_CHAR_COUNT ];
};

internal void
alignFont( FONT * font, uint8 ** memory ) {
	uint8 * ptr = *memory;
	
	for( int32 char_index = 0; char_index < FONT_CHAR_COUNT; char_index++ ) {
		CHAR_TEXTURE * char_texture = font->char_texture + char_index;
		
		char_texture->memory = ptr;
		ptr += ( char_texture->width * char_texture->height );
	}
	
	*memory = ptr;
}