
#define MAX_GROUND_COUNT  ( 64 )
struct GROUND_STATE {
	int32 count;
	rect  bound[ MAX_GROUND_COUNT ];
};

internal void
draw( BACKBUFFER * backbuffer, VIEWPORT * camera, GROUND_STATE * groundState ) {
	for( int32 ground_index = 0; ground_index < groundState->count; ground_index++ ) {
		rect    bound = groundState->bound[ ground_index ];
		rect adjBound = rectMM( transformToView( camera, bound.min ), transformToView( camera, bound.max ) );
		for(    flo32 groundY = adjBound.bottom; groundY < adjBound.top;   groundY += 24.0f ) {
			for( flo32 groundX = adjBound.left;   groundX < adjBound.right; groundX += 24.0f ) {
				rect block_bound = rectBLD( Vec2( groundX, groundY ), Vec2( 24.0f, 24.0f ) );
				drawBox( backbuffer, block_bound, 0xFF000000, 0xFF3C1400 );
			}
		}
	}
}