
struct KILL_TRIANGLE {
	int8 xPos;
	int8 yPos;
	uint8 colorR;
	uint8 colorG;
};

struct KILL {
	uint32 counter;
	KILL_TRIANGLE triangle[ 7 ];
};

#define MAX_KILL_COUNT  ( 1024 )
struct KILL_STATE {
	int32 count;
	rect bound[ MAX_KILL_COUNT ];
	KILL  kill[ MAX_KILL_COUNT ];
};

internal KILL_TRIANGLE
newTriangle() {
	KILL_TRIANGLE result = {};
	result.xPos   = ( rand() % 20 ) - 6;
	result.yPos   = ( rand() % 12 ) - 6;
	result.colorR = ( rand() % 60 ) + 195;
	
	int32 g = ( rand() % 80 ) + ( rand() % 80 ) + ( rand() % 80 ) - 120;
	result.colorG = ( g < 0 ) ? ( uint8 )( -g ) : ( uint8 )g;
	
	return result;
}

internal void
update( KILL_STATE * killState ) {
	for( int32 kill_index = 0; kill_index < killState->count; kill_index++ ) {
		KILL * kill = killState->kill + kill_index;
		
		for( int32 triangle_index = 0; triangle_index < 7; triangle_index++ ) {
			kill->counter++;
			if( kill->counter == 10 ) {
				kill->counter = 0;
				kill->triangle[ triangle_index ] = newTriangle();
			}
		}
	}
}

internal void
draw( BACKBUFFER * backbuffer, VIEWPORT * camera, KILL_STATE * killState ) {
	for( int32 kill_index = 0; kill_index < killState->count; kill_index++ ) {
		rect    bound = killState->bound[ kill_index ];
		rect adjBound = rectMM( transformToView( camera, bound.min ), transformToView( camera, bound.max ) );
		drawRect( backbuffer, adjBound, 0xFFFFAF78 );
		
		KILL * kill = killState->kill + kill_index;
		for( int32 triangle_index = 0; triangle_index < 7; triangle_index++ ) {
			KILL_TRIANGLE triangle = kill->triangle[ triangle_index ];
			
			vec2 pos     = adjBound.min + Vec2( ( flo32 )triangle.xPos, ( flo32 )triangle.yPos );
			rect tri_bound   = rectBLD( pos, Vec2( 16.0f, 28.0f ) );
			uint32 color = ( 0xFF000000 ) | ( triangle.colorR << 16 ) | ( triangle.colorG << 8 );
			drawTriangle( backbuffer, tri_bound, color );
		}
	}
}
